/*
 * annex.h
 * Copyright (C) 2021 Aitor Cuadrado Zubizarreta <aitor_czr@gnuinos.org>
 * 
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * See the LICENSE file. * 
 */
 

#ifndef __ANNEX_H__
#define __ANNEX_H__

#include <iostream>
#include <vector>

namespace Hopman
{

using namespace std;
		
class Annex
{  
public:
    Annex(int, char**, int, int);
    virtual ~Annex();
			
    // TODO: make private using getters to access them
    int x_screen, y_screen;
    vector<string> args;
    string mypid,
           current_path,
           path_to_the_helper,
           watch_dir,
           socket,
           helper_socket,
           worker_socket,
           app_icon,
           eject_icon,
           removed_icon,
           warning_icon;
		
private:
    void get_current_path();
    void set_pixmaps();
    void set_path_to_the_helper();
};
			
} // namespace Hopman

#endif // __ANNEX_H__
