/*
 * blk_model.h
 * Copyright (C) 2021 Aitor Cuadrado Zubizarreta <aitor_czr@gnuinos.org>
 * 
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * See the LICENSE file. * 
 */
 
 
#ifndef __BLK_MODEL_H__
#define __BLK_MODEL_H__

#include <gtkmm.h>

namespace Hopman {
	
using namespace std;

class BlkModel : public Gtk::TreeModel::ColumnRecord
{
public:
    BlkModel();
    virtual ~BlkModel();
   
    Gtk::TreeModelColumn<string>                      device;
    Gtk::TreeModelColumn<string>                      fstype;
    Gtk::TreeModelColumn<string>                      size;
    Gtk::TreeModelColumn<Glib::RefPtr<Gdk::Pixbuf>>   icon;
    Gtk::TreeModelColumn<string>                      vendor;
};

} // namespace Hopman

#endif // __BLK_MODEL_H__
