/*
 * eject_dialog.h
 * Copyright (C) 2021 Aitor Cuadrado Zubizarreta <aitor_czr@gnuinos.org>
 * 
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * See the LICENSE file. * 
 */

 
#ifndef __EJECT_DIALOG_H__
#define __EJECT_DIALOG_H__

#include <gtkmm.h>
#include <thread>

namespace Hopman {
	
using namespace std;

class EjectDialog : public Gtk::Dialog
{
public:
    EjectDialog( string, string, string, string );  
    virtual ~EjectDialog();

private:
    string strDevice, strSocket, strEject; 	
    Gtk::Alignment m_Align1, m_Align2;
    Gtk::Image m_Image;
    Gtk::Label m_Label;
    Gtk::Button *m_Button_Cancel, *m_Button_Eject;
    thread *m_WorkerThread;
    Gtk::ProgressBar  m_ProgressBar;
	
    sigc::slot<void> op_client;
    sigc::connection m_connection_timeout;
	  
    bool on_timeout();
    bool m_bActivityMode;
	
    void on_eject();
};

} // namespace Hopman

#endif // __EJECT_DIALOG_H__

