/*
 * fpipe.cpp
 * Copyright (C) 2021 Aitor Cuadrado Zubizarreta <aitor_czr@gnuinos.org>
 * 
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * See the LICENSE file. * 
 */


#include <iostream>
#include <filesystem>
#include <memory>
#include <vector>
#include <sstream>      // stringstream
#include <stdexcept>

#include "fpipe.h"

namespace Hopman {
	
fPipe::fPipe()
{

}

fPipe::~fPipe()
{

}

vector<string> fPipe::get_output(string cmd)
{    
    vector<string> output;
    output.begin();
	
    try {		
        char ch;
        string str;
				
        unique_ptr<FILE, decltype(&pclose)> fp(::popen(cmd.c_str(), "r"), &pclose);			
        while ((ch = (char)fgetc(fp.get()))!=EOF) {			
            if(ch != '\n') {				
                stringstream ss;
                ss << ch;
                str.append(ss.str());                
            } else {				
                output.push_back(str);
                str.clear();
            }
        }
    }
	
    catch(exception const& e) {
			
        throw runtime_error("Sorry, there was an error opening the pipe\n");		
    };
	
    return output;
}

} // namespace Hopman
