/*
 * hopman_ui.h
 * Copyright (C) 2021 Aitor Cuadrado Zubizarreta <aitor_czr@gnuinos.org>
 * 
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * See the LICENSE file. * 
 */
 

#ifndef __HOPMAN_UI_H__
#define __HOPMAN_UI_H__

#include <gtkmm.h>
#include <iostream>
#include <memory>

namespace Hopman
{
	
// Forward declarations
class Annex;
class BlkTree;

using namespace std;
	
class Hopman_Ui : public Gtk::Window
{
public:
    Hopman_Ui(const Hopman::Annex&);
    virtual ~Hopman_Ui();
	
    // TODO: make protected	
    Gtk::Spinner m_Spinner;
    Gtk::Label m_Label;
    
private:
    string mypid;
    
protected:
    //Child widgets:
    Gtk::HBox m_HBox;
    Gtk::VBox m_VBox;
    Hopman::BlkTree *m_BlkTree;
	
    // Signal handlers
    bool on_my_window_state_event(GdkEventWindowState*);
    bool on_motion_notify_event(GdkEventMotion*);
    bool on_entry_focus_out_event(GdkEventFocus*);
};

} // namespace Hopman

#endif //__HOPMAN_UI_H__
