/*
 * svr.h
 * Copyright (C) 2021 Aitor Cuadrado Zubizarreta <aitor_czr@gnuinos.org>
 * 
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * See the LICENSE file. * 
 */


#ifndef __SVR_H__
#define __SVR_H__

#include <glibmm.h>
#include <thread>
#include <unistd.h>
#include <signal.h>  
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>      /* for UNIX sockets */

#define PROTOCOL 0       /* protocol by default */

namespace Hopman
{
	
using namespace std;
	
class Svr
{
public:
    Svr(string);
    virtual ~Svr();
			
    // TODO: make private
    void dispatch(vector<string>);
  
private:
    Glib::Threads::Thread *thread;
	
    string fileDescriptor;
    int dfServer, dfClient; 
    socklen_t longServer, longClient; 

    struct sockaddr_un dirUNIXServer;  
    struct sockaddr_un dirUNIXClient;  

    struct sockaddr* puntSockServer;  
    struct sockaddr* puntSockClient;
    void send_fileDescriptor(vector<string>);
};

} // namespace Hopman

#endif // __SVR_H__
