/*
 * suid.cpp
 * Copyright (C) 2021 Aitor Cuadrado Zubizarreta <aitor_czr@gnuinos.org>
 * 
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * See the LICENSE file. * 
 */
 

#include <iostream>
#include <vector>
#include <memory>
#include <unistd.h>

#include "gtkmm/cli.h"


void blkid();
void eject(std::string);

/* *
 *     MAIN                                                 
 */

int main(int argc, char **argv)
{
    if(argc < 2) {
		
        throw std::runtime_error("No arguments received from the gui.\n");
    }
	
    std::unique_ptr<Hopman::Cli> cli( new Hopman::Cli( argv[1] ) );
	
    switch(std::stoi(cli->messages[0])) {
		
        case 0: blkid();
                break;
		
        case 1: eject(cli->messages[1]);
                break;
			
        default: throw std::runtime_error("Wrong argument\n");
    }
	
    return EXIT_SUCCESS;
}

void blkid()
{
    sync();
    setuid(0);
    execl("/sbin/blkid", "blkid", (char*) NULL);
}

void eject(std::string str)
{
    sync();
    setuid(0);
    execl("/usr/bin/eject", "eject", str.c_str(), (char*) NULL);
}
